BMapCom.Template.create("ScopeTicketViewTpl", {
body:function ($data,$id) {
var $helpers=BMapCom.Template.helpers,hasMore=$data.hasMore,list=$data.list,t=$data.t,$escape=$helpers.$escape,tag=$data.tag,$out='';$out+='<div class="scope-tickets-header">\r\n		门票预订\r\n		';
 if(hasMore) {
$out+='\r\n		<div class="scope-more-tickets-btn" data-ek="scopeMoreTicketsBtn"><span>查看更多</span><i></i></div>\r\n		';
 } 
$out+='\r\n	</div>\r\n	<div class="scope-tickets-list">\r\n		';
list.forEach(function(t){
$out+='\r\n		<section class="scope-ticket-item">\r\n			<div class="scope-ticket-wrap">\r\n				<div class="scope-left-cont" data-ticketid="';
$out+=$escape(t.ticket_id);
$out+='" data-ek="scopeTicketNoticeBtn">\r\n					<h6 class="scope-ticket-title">';
$out+=$escape(t.name);
$out+='</h6>\r\n					<div class="scope-ticket-tips">\r\n						';
if(t.is_adult_ticket && t.is_into_scope) { 
$out+='\r\n						<strong class="scope-ticket-into">保</strong>\r\n						';
} 
$out+='\r\n						';
 t.tags.forEach(function(tag){
$out+='\r\n						<span>';
$out+=$escape(tag);
$out+='</span>\r\n						';
})
$out+='\r\n					</div>\r\n					';
if(t.promotion_tag) {
$out+='\r\n					<span class="scope-ticket-promotion">';
$out+=$escape(t.promotion_tag);
$out+='</span>\r\n					';
}
$out+='\r\n					<div class="scope-ticket-notice-btn" data-ticketid="';
$out+=$escape(t.ticket_id);
$out+='" data-ek="scopeTicketNoticeBtn">预订须知</div>\r\n				</div>\r\n				<div class="scope-right-cont" data-ticketid="';
$out+=$escape(t.ticket_id);
$out+='" data-ek="scopeTicketBookBtn">\r\n					<div class="scope-right-wrap">\r\n						<div class="scope-price-cont">\r\n							';
if(t.market_price>t.price) {
$out+='\r\n							<span class="scope-original-price">¥';
$out+=$escape(t.market_price);
$out+='</span>\r\n							';
}
$out+='\r\n							<span class="scope-unit">¥</span>\r\n							<span class="scope-price">';
$out+=$escape(t.price);
$out+='</span>\r\n						</div>\r\n						<div class="scope-book-btn">\r\n							<div class="scope-book-ticket-btn">预订</div>\r\n							<div class="scope-pay-type">';
$out+=$escape(t.pay_way);
$out+='</div>\r\n						</div>\r\n					</div>\r\n				</div>\r\n			</div>\r\n		</section>\r\n		';
})
$out+='\r\n	</div>\r\n    <div class="notice-popup-warp">\r\n        <div class="popup-header mod-dialog-header-wrap">\r\n            <span>预订须知</span>\r\n            <span class="btn-close" data-ek="noticeCloseBtn"></span>\r\n        </div>\r\n        <div class="mod-dialog-iscroll-wrap">\r\n        	<div class="popup-content"></div>\r\n        </div>\r\n        <div class="popup-footer mod-dialog-footer-wrap">\r\n        	<div class="notice-order-info">\r\n        		<span class="scope-unit">¥</span>\r\n				<span class="scope-price">0</span>\r\n				在线支付\r\n        	</div>\r\n            <div class="btn-book" data-ek="noticePayBtn">立即预订</div>\r\n        </div>\r\n    </div>';
return new String($out);
}});
BMapCom.Plugin.define(function(PluginBuilder) {
	var plg = PluginBuilder.create({
		hasTemplate: true,
		hasCSS: true
	});

	var cacheParams;
	var SCOPE_COMMON_UTIL;
    try {
        SCOPE_COMMON_UTIL = SCOPE_COMMON_UTIL ;
    }catch(e) {};

	//加载相关类库
	var loadJS = function(fn) {
		var needJS = [];
		if (!window.Zepto) {
			needJS.push('!zepto');
		}
		if (!window.IScroll) {
			needJS.push('!iscroll');
		}
		if (!window.jsmod) {
			needJS.push('!jsmod');
		}
		if (needJS.length) {
			BMapCom.Loader.script(needJS).ok(fn);
		} else {
			fn();
		}

	}

	var getTickets = function(container, uid) {
		// 远程取得数据景点门票数据
		$.ajax({
			url: 'http://client.map.baidu.com/scope?qt=ticket_list',
			dataType: "jsonp",
			data: {
			    v: 2.1,
                request_from: BMapCom.util.platform.isAndroid() ? 'android' : 'iphone',
                uid: cacheParams.uid,
                qfrom: 'map_webview',
                from: "webview",
                resid: "01",
                pn: 1,
                rn: cacheParams.showCount < 0 ? 10 : cacheParams.showCount
			},
			timeout: 5000,
			success: function(data) {
				if (data.err_no == 0 && ((data.data.length && data.data.length > 0) || data.data.total && data.data.total > 0)) {
					container.show();
					Tickets.init(container, data.data);
					cacheParams.succ && $.isFunction(cacheParams.succ) && cacheParams.succ();
				} else {
					cacheParams.fail && $.isFunction(cacheParams.fail) && cacheParams.fail();
				}
			},
			error: function() {
				cacheParams.fail && $.isFunction(cacheParams.fail) && cacheParams.fail();
			}
		});
	}

	var Tickets = {
		init: function(container, data) {
			var self = this;

			self.tickets = {}; //门票信息
			self.container = container;
			self.render(plg.template.body, self.doData(data));

			//预订须知
			self.wrapNotice = $(".notice-popup-warp");
			self.dg = new jsmod.ui.Dialog({
				element: self.wrapNotice,
				isIScroll: true,
				width: document.body.clientWidth - 20,
				height: "70%"
			});

			var evt = new BMapCom.EventDelegater(self.container.get(0));
			self.initEvents(evt);
		},

		//渲染页面
		render: function(template, data) {
			this.container.html(template(data));
			if (cacheParams.page_from && cacheParams.page_from == "listPg") {
			    BMapCom.Kernel.notify('webPageReady');
			}
		},

		//修复数据
		doData: function(data) {
			var ret = {
				hasMore: false,
				list: []
			};

			var self = this,
				list = data.tickets;
			var srcList = data.tickets_from || ['ctripticket', 'qunar'];
			var statTickets = [];
			for (var i = 0; i < srcList.length * 2; i++) {
				statTickets[i] = 0;
			}

			if (list && list.length > 0) {
				if (cacheParams.showCount > 0) {
					ret.hasMore = data.total > cacheParams.showCount ? true : false;
					list = list.slice(0, cacheParams.showCount); //适配v1.0 因为1.0会返回所有数据
				}
                var count = 1;
				ret.list = list.map(function(t) {
				    var key = t.ticket_id || 'ticket_' + count;
					self.tickets[key] = t;
					var src = t.src || t.partner_id.split('_')[0];
					var jump = t.jump || 1;
					statTickets[srcList.indexOf(src) * 2 + jump - 1] ++;

					return {
						ticket_id: key,
						tags: t.tag.split('|'),
						name: t.name,
						price: t.price,
						market_price: t.market_price,
						pay_way: t.pay_way || '在线支付',
						is_adult_ticket: (t.extra && t.extra.ticket_type && t.extra.ticket_type == 'A') ? 1 : 0,
						is_into_scope: (t.extra && t.extra.enter_guarantee) ? 1 : 0,
						promotion_tag: t.promotion && t.promotion.title
					};
				});
			}

			//统计
			this.statisticsDetailPageInfo("totalTicketshow", "", "", "show", {
				ticketsStat: statTickets.join("-")
			});

			return ret;
		},

		//获取非闭环预订须知  异步
		setAsynNotice: function(ticket) {
			var self = this;
			var html = '<div class="scope-ticket-header">' + ticket.name + '</div><div class="scope-widget-line"></div>';
			if (ticket.promotion && ticket.promotion.title) {
				html += '<div class="scope-ticket-promotion-tip">该门票参与了' + ticket.promotion.title + '活动</div>';
			}
			SCOPE_COMMON_UTIL && SCOPE_COMMON_UTIL.showLoading();
			BMapCom.Loader.jsonp(ticket.tip_url).ok(function(result) {
				var list = result.data.data;
				if (result.data.err_no == 0 && list && list.length) {
					list.forEach(function(e) {
						html += '<div class="scope-notice-title">' + e.title + '</div>';
						html += '<div class="scope-notice-content">' + e.content.join('<br>') + '</div>'
					});
					
					self.wrapNotice.find('.popup-content').html(html.replace(/\r?\n/g, '<br>'));
					self.wrapNotice.find('.notice-order-info').html('<span class="scope-unit">¥</span><span class="scope-price">' + ticket.price + '</span>' + (ticket.pay_way || '在线支付'));
					self.wrapNotice.find('.btn-book').data('ticketid', ticket.ticket_id);
					self.dg.show();
				} else {
					new jsmod.ui.Toast("获取预订须知失败！");
				}
				SCOPE_COMMON_UTIL && SCOPE_COMMON_UTIL.hideLoading();
			});
		},

		//获取闭环预订须知  同步
		setSyncNotice: function(ticket) {
			var self = this;
			var html = '<div class="scope-ticket-header">' + ticket.name + '</div><div class="scope-widget-line"></div>';
			if (ticket.promotion && ticket.promotion.title) {
				html += '<div class="scope-ticket-promotion-tip">该门票参与了' + ticket.promotion.title + '活动</div>';
			}
			
			ticket.tip.forEach(function(e) {
				html += '<div class="scope-notice-title">' + e.title + '</div>';
				html += '<div class="scope-notice-content">' + e.content.join('<br>') + '</div>'
			});
			
			self.wrapNotice.find('.popup-content').html(html.replace(/\r?\n/g, '<br>'));
			self.wrapNotice.find('.notice-order-info').html('<span class="scope-unit">¥</span><span class="scope-price">' + ticket.price + '</span>' + (ticket.pay_way || '在线支付'));
			self.wrapNotice.find('.btn-book').data('ticketid', ticket.ticket_id);
			self.dg.show();
		},

		//设置预订须知内容
		setNoticeContent: function(ticketid) {
			var ticket = this.tickets[ticketid];
			if (ticket.tip && ticket.tip.length) {
				this.setSyncNotice(ticket);
			} else if (ticket.tip_url) {
				this.setAsynNotice(ticket);
			} else {
				new jsmod.ui.Toast("获取预订须知失败！");
			}
            
            //notice统计
            var src = ticket.src || ticket.partner_id.split('_')[0];
            var isSealedPay = !(ticket.jump && ticket.jump == 2 && ticket.mb_url);
            this.statisticsDetailPageInfo('notice', src, isSealedPay, 'click', {
                ticketid: ticketid,
                bd_tid: ticket.id,
                request_id: ticket.request_id,
                idx: ticket.idx
            });
		},

		//预订
		bookTicket: function(ticketid, from) {
			var o = this.tickets[ticketid];
			var src = o.src || o.partner_id.split('_')[0];
			var isSealedPay = !(o.jump && o.jump == 2 && o.mb_url);
			var entranceParam = this.doDealEntranceParam(o);
			//booking统计
			this.statisticsDetailPageInfo('booking', src, isSealedPay, 'click', {
			    ticketid: ticketid,
			    bd_tid: o.id,
			    click_from: from,
                request_id: o.request_id,
                idx: o.idx
			});
			//区分一下行业，如果是景点自己行业，直接changePage
			if (cacheParams.orderFrom == 'mapScope') {
				BMapCom.Kernel.notify('changePage', entranceParam);
			} else {
				BMapCom.Kernel.notify('request', entranceParam);
			}
		},

		//处理booking跳转
		doDealEntranceParam: function(ticket) {
			var entranceParam;
			var src = ticket.src || ticket.partner_id.split('_')[0];
			//非闭环 跳第三方页面
			if (ticket.jump && ticket.jump == 2 && ticket.mb_url) {
				//跳转第三方支付页面
				/*entranceParam = {
					"page": "defaultWebViewPage",
					"pageParam": {
						"url": ticket.mb_url,
						"src_from": cacheParams.src_from,
						"qid": cacheParams.qid,
						"resid": cacheParams.resid
					}
				}*/

				entranceParam = {
					"category": "mainmap",
                    "method": BMapCom.ComRequestMethod.DISPATCH,
                    "param": {
                        "target": "web_shell_page",
                        "base_params": {
                            "webview_url": ticket.mb_url,
                            "webshell_is_share_show": false
                        }
                    }
				}
			} else {
				if (cacheParams.orderFrom == 'mapScope') {
					//景点跳自己组件
					entranceParam = {
						"page": "filloutPage",
						"pageParam": {
							"partner_id": src,
							"scope_id": ticket.scope_id,
							"scope_name": cacheParams.scope_name || ticket.name,
							"ticket_id": ticket.ticket_id,
							"bid": cacheParams.uid,
							"extra": ticket.extra,
							"is_adult_ticket": (ticket.extra && ticket.extra.ticket_type && ticket.extra.ticket_type == 'A') ? 1 : 0,
                            "is_into_scope": (ticket.extra && ticket.extra.enter_guarantee) ? 1 : 0,
							"order_from": cacheParams.order_from || "map_scope",
							"src_from": cacheParams.src_from,
							"qid": cacheParams.qid,
							"resid": "01"
						}
					};
				} else {
					//闭环跳转填单页
					entranceParam = {
						"category": "scenery",
						"method": BMapCom.ComRequestMethod.DISPATCH,
						"param": {
							"target": "scenery_order_fillout_request",
							"base_params": {
								"partner_id": src,
								"scope_id": ticket.scope_id,
								"scope_name": cacheParams.scope_name || ticket.name,
								"ticket_id": ticket.ticket_id,
								"bid": cacheParams.uid,
								"extra": ticket.extra,
								"is_adult_ticket": (ticket.extra && ticket.extra.ticket_type && ticket.extra.ticket_type == 'A') ? 1 : 0,
                                "is_into_scope": (ticket.extra && ticket.extra.enter_guarantee) ? 1 : 0,
								order_from: cacheParams.order_from,
								src_from: cacheParams.src_from,
								qid: cacheParams.qid
							}
						}
					};
				}
			}
			return entranceParam;
		},

		initEvents: function(evt) {
			var self = this;
			// 预订须知
			evt.on("scopeTicketNoticeBtn:tap", function() {
				var ticketid = $(this).attr("data-ticketid");
				self.setNoticeContent(ticketid);
			});

			//预订
			evt.on("scopeTicketBookBtn:tap", function() {
				var orderid = $(this).attr("data-ticketid");
				self.bookTicket(orderid, 'detail');
			});

			//查看更多门票
			evt.on("scopeMoreTicketsBtn:tap", function() {
				if (BMapCom.config('monkeyTest')) {
					return false;
				}
				var partner_id = "partner_list=",
					entranceParam;
				for (var k in self.tickets) {
					if (self.tickets.hasOwnProperty(k) && self.tickets[k]) {
						partner_id += self.tickets[k].partner_id;
						break;
					}
				}

				if (cacheParams.orderFrom == 'mapScope') {
					entranceParam = {
						"page": "bookListPage",
						"pageParam": {
							"uid": cacheParams.uid,
							"src": partner_id,
							"src_from": cacheParams.src_from,
							"qid": cacheParams.qid
						}
					};
					BMapCom.Kernel.notify('changePage', entranceParam);
				} else {
					entranceParam = {
						"category": "scenery",
						"method": BMapCom.ComRequestMethod.DISPATCH,
						"param": {
							"target": "scenery_booklist_request",
							"base_params": {
								"uid": cacheParams.uid,
								"src": partner_id,
								order_from: cacheParams.order_from,
								src_from: cacheParams.src_from,
								qid: cacheParams.qid
							}
						}
					};
					BMapCom.Kernel.notify('request', entranceParam);
				}
			});

			//关闭预订须知
			self.wrapNotice.find('.btn-close').on("tap", function() {
				self.dg.hide();
				self.dg.iscroll.scrollTo(0, 0);
			});

			//立即支付
			self.wrapNotice.find('.btn-book').on("tap", function() {
				var orderid = $(this).attr("data-ticketid");
				self.dg.hide();
				self.bookTicket(orderid, 'detailNotice');
			});
		},

		//在线统计： key值， 来源， 是否闭环， 动作
		statisticsDetailPageInfo: function(key, src, isSealedPay, act, ext) {
			var keys = [];
			if (src) {
				keys.push(src);
				isSealedPay && keys.push("sealed");
			}
			keys.push(key);
			act = act || "click";
			var stat = {
				"da_src": "poidetailpg.coreItems." + keys.join("_"),
				"da_trd": "scope",
				"da_act": act,
				"da_model": "plugin_scenery",
				"page_from": cacheParams.page_from || "detailPg",
				"order_from": cacheParams.order_from,
				"bid": cacheParams.uid,
				"src_from": cacheParams.src_from,
				"qid": cacheParams.qid,
				"t": Date.now()
			}

			if (ext) {
				stat = $.extend(stat, ext);
			}

			BMapCom.Stat.sendOnline(stat);
		}
	};

	plg.delegate({
		onInstantiate: function(baseData, container) {
			cacheParams = baseData;
			cacheParams.order_from = cacheParams.order_from || 'map_scope';
			cacheParams.orderFrom = cacheParams.order_from.replace(/[_-](\w{1})/g, function(a, b) {
				return b.toLocaleUpperCase()
			});
			cacheParams.showCount = cacheParams.order_from == 'map_scope' ? cacheParams.showCount : 3;
			cacheParams.showCount = isNaN(+cacheParams.showCount) ? -1 : +cacheParams.showCount;

			loadJS(function() {
				container = $(container)
				if (container.length > 0 && cacheParams.uid) {
					getTickets(container, baseData.uid);
				}
			});
		}
	});
	return plg;
});