BMapCom.AppCore.ready(function(entranceParam) {

	BMapCom.config('templateHtmlMode', false);
	BMapCom.config('monkeyTest', window.isMonkey);
	window.pageParam = entranceParam.pageParam;
	
	BMapCom.Loader.script(["!zepto", "!iscroll", "!jsmod"]).ok(function($) {
	    try {
            SCOPE_COMMON_UTIL && SCOPE_COMMON_UTIL.init();     
	    } catch(e) {}
	    
	    BMapCom.Loader.script('lib/tracker.js').ok(function() {

			//入口协议解析
			if (entranceParam && entranceParam.page) {
				var pageParam;
				switch (entranceParam.page) {
					case 'detailPage':
						pageParam = entranceParam.pageParam;
						if (pageParam && pageParam.uid) {
							//可传字段:pageParam.option.index
							BMapCom.AppCore.changePage('detailPage', pageParam);
						} else {
							new jsmod.ui.Alert('详情页入口参数错误');
						}
						break;
					case 'imagePage':
						pageParam = entranceParam.pageParam;
						if (pageParam && pageParam.uid) {
							BMapCom.AppCore.changePage('imagePage', pageParam);
						} else {
							new jsmod.ui.Alert('图片页入口参数错误');
						}
						break;
					case 'imageDetailPage':
						pageParam = entranceParam.pageParam;
						if (pageParam && pageParam.option && pageParam.option.imageList) {
							//如果传入图片列表数据，则不再发送请求，直接渲染
							pageParam.renderImmediately = true;
							BMapCom.AppCore.changePage('imageDetailPage', pageParam);
						} else if (pageParam && pageParam.uid) {
							//可选参数option.imageFrom，传入baidumap显示百度地图的图片，未传入则显示所有来源图片
							pageParam.renderImmediately = false;
							BMapCom.AppCore.changePage('imageDetailPage', pageParam);
						} else {
							new jsmod.ui.Alert('图片详情页入口参数错误');
						}
						break;
					case 'commentPage':
						pageParam = entranceParam.pageParam;
						if (pageParam && pageParam.uid && pageParam.poiName) {
							BMapCom.AppCore.changePage('commentPage', pageParam);
						} else {
							new jsmod.ui.Alert('评论页入口参数错误');
						}
						break;
					case 'subSceneryPage':
						pageParam = entranceParam.pageParam;
						if (pageParam && pageParam.uid && pageParam.subScene) {
							BMapCom.AppCore.changePage('subSceneryPage', pageParam);
						} else {
							new jsmod.ui.Alert('子景点页入口参数错误');
						}
						break;
					case 'topicDetailPage':
						pageParam = entranceParam.pageParam;
						if (pageParam) {
							BMapCom.AppCore.changePage('topicDetailPage', pageParam);
						} else {
							new jsmod.ui.Alert('主题详情页入口参数错误');
						}
						break;
					case 'specialTopicPage':
						pageParam = entranceParam.pageParam;
						if (pageParam) {
							BMapCom.AppCore.changePage('specialTopicPage', pageParam);
						} else {
							new jsmod.ui.Alert('主题详情页入口参数错误');
						}
						break;
					case 'bookListPage':
						pageParam = entranceParam.pageParam;
						if (pageParam) {
							BMapCom.AppCore.changePage('bookListPage', pageParam);
						} else {
							new jsmod.ui.Alert('门票预订列表页参数错误');
						}
						break;
                    case 'grouponListPage':
                        pageParam = entranceParam.pageParam;
                        if (pageParam) {
                            BMapCom.AppCore.changePage('grouponListPage', pageParam);
                        } else {
                            new jsmod.ui.Alert('直营团购列表页参数错误');
                        }
                        break;
					case 'sceneryDetailPage':
						pageParam = entranceParam.pageParam;
						if (pageParam) {
							BMapCom.AppCore.changePage('sceneryDetailPage', pageParam);
						} else {
							new jsmod.ui.Alert('路线详情页参数错误');//风景详情
						}
						break;	
					case 'orderManagerPage':
						pageParam = entranceParam.pageParam;
						BMapCom.AppCore.changePage('orderManagerPage', pageParam);
						break;
					case 'orderCompletePage':
						pageParam = entranceParam.pageParam;
						if (pageParam && pageParam.order_id) {
							BMapCom.AppCore.changePage('orderCompletePage', pageParam);
						} else {
							new jsmod.ui.Alert('订单成单页参数错误');
						}
						break;
					case 'orderDetailPage':
						pageParam = entranceParam.pageParam;
						if (pageParam && pageParam.order_id) {
							BMapCom.AppCore.changePage('orderDetailPage', pageParam);
						} else {
							new jsmod.ui.Alert('订单详情页参数错误');
						}
						break;
					case 'orderCenterPage':
						pageParam = entranceParam.pageParam;
						if (pageParam) {
							BMapCom.AppCore.changePage('orderCenterPage', pageParam);
						} else {
							new jsmod.ui.Alert('订单中心页参数错误');
						}
						break;
					case 'channelPage':
						pageParam = entranceParam.pageParam;
						if (pageParam) {
							BMapCom.AppCore.changePage('channelPage', pageParam);
						} else {
							new jsmod.ui.Alert('频道页参数错误');
						}
						break;
					case 'topicListPage':
						pageParam = entranceParam.pageParam;
						if (pageParam) {
							BMapCom.AppCore.changePage('topicListPage', pageParam);
						} else {
							new jsmod.ui.Alert('专题列表页参数错误');
						}
						break;
					case 'voucherPage':
						pageParam = entranceParam.pageParam;
						if (pageParam) {
							BMapCom.AppCore.changePage('voucherPage', pageParam);
						} else {
							new jsmod.ui.Alert('优惠券页参数错误');
						}
						break;
					case 'couponPage':
						pageParam = entranceParam.pageParam;
						if (pageParam) {
							BMapCom.AppCore.changePage('couponPage', pageParam);
						} else {
							new jsmod.ui.Alert('领券页参数错误');
						}
						break;
					case 'ticketDetailPage':
						pageParam = entranceParam.pageParam;
						if (pageParam) {
							BMapCom.AppCore.changePage('ticketDetailPage', pageParam);
						} else {
							new jsmod.ui.Alert('订单中心页参数错误');
						}
						break;
					case 'orderFillPage':
						pageParam = entranceParam.pageParam;
						if (pageParam) {
							BMapCom.AppCore.changePage('orderFillPage', pageParam);
						} else {
							new jsmod.ui.Alert('填单页参数错误');
						}
						break;
					default:
						new jsmod.ui.Alert('未指定页面');
				}
			}
		})
	});
});