BMapCom.Template.create("ActionBannerViewTpl", {
bannerList:function ($data,$id) {
var $helpers=BMapCom.Template.helpers,$out='';$out+='<div class="banner-list-container" id="bannerListContainer">\n        <ul class="banner-list-scroller" id="bannerListScroller">\n        </ul>\n        <!--<div class="indicator-wrapper">       \n            <div id="indicator">\n                <div id="dotty"></div>\n            </div>\n        </div>-->\n    </div>';
return new String($out);
},
bannerListItem:function ($data,$id) {
var $helpers=BMapCom.Template.helpers,i=$data.i,imageData=$data.imageData,$escape=$helpers.$escape,$out=''; for (var i = 0; i < imageData.length; i++) { 
$out+='\n    <li class="slide banner-it-li"  data-ek="gotoActionPage">\n        <div class="banner-it-main">\n            <div class="banner-it-img-container">\n                <img id=\'\' class="banner-it-img" src="';
$out+=$escape( imageData[i].imgurl);
$out+='" data-index="';
$out+=$escape( i);
$out+='">\n            </div>\n            <!--<div class="banner-it-info">\n            </div>-->\n        </div>\n    </li>\n';
 } 
return new String($out);
}});
/**
 * @file MBC品牌活动可滑动banner组件
 * @author [litingyu@baidu.com]
 */
BMapCom.Plugin.define(function(PluginBuilder) {
    var pluginBasicData = null;     // 渲染插件时，由外部传入的数据
    var container = null;
    var dispatcher = new BMapCom.EventDispatcher(container);
    var listItemData = null;
    var plg = PluginBuilder.create({
        hasTemplate: true,
        hasCSS: true
    });

    function SailfishSlider(selector, liWidth, liNum) {
        if (!selector) {
            console.error('selector can not be null');
        }
        this.dom = document.querySelector(selector);
        if (liNum) {
            // this.liNum 给下方的locator用，指的是实际上一共有多少个滑动元素（如两个）；
            // this.total 给滑动元素用，包括了为了滑动效果而多加的滑动元素（在实际有两个的时候有 四个）；
            // 当滑动元素大于2个时，二者是相等的；当共有2个元素时，为了可以循环滑动多创建两个
            this.liNum = liNum;
        }
        if (this.liNum == 2) {
            this.dom.innerHTML += this.dom.innerHTML;
        };
        var cn = this.dom.className;
        if (cn) {
            this.dom.className += ' sailfishSlider';
        } else {
            this.dom.className = 'sailfishSlider';
        }
        if (liWidth) {
            this.w = liWidth;
        } else {
            this.w = this.dom.offsetWidth;
        }
        
        this.MIN_X_DIS = 20;     // 只有水平拖动超过20，才会有水平拖动效果
        this.iw = [];
        this.currentIndex = 0;
        this.bindEvent();
        this.render(0);
        var me = this;
        me.autoScrollFun = function () {
            me.scrollToLeft();
        }
        me.autoScrollTimer = setInterval(me.autoScrollFun, 5000);
    }

    SailfishSlider.prototype.bindEvent = function () {
        var me = this;
        me.dom.removeEventListener('touchstart', touchStart);
        me.dom.addEventListener('touchstart', touchStart);

        me.dom.removeEventListener('touchmove', touchMove);
        me.dom.addEventListener('touchmove', touchMove);

        me.dom.removeEventListener('touchend', touchEnd);
        me.dom.addEventListener('touchend', touchEnd);

        function touchStart(e) {
            e.preventDefault();
            if (me.autoScrollTimer) {
                clearInterval(me.autoScrollTimer); // 禁止自动轮播
            };
            if (me.isBusy) return;
            var tt = e.touches[0];
            me.startX = tt.pageX;
            me.canDrag = true;
        }

        function touchMove(e) {
            e.preventDefault();
            if (me.autoScrollTimer) {
                clearInterval(me.autoScrollTimer); // 禁止自动轮播
            };
            if (me.canDrag) {
                var tt = e.touches[0];
                var dis = tt.pageX - me.startX;
                // me.render(dis);
                if (Math.abs(dis) > me.MIN_X_DIS) {
                    me.render(dis > 0 ? dis - me.MIN_X_DIS: dis + me.MIN_X_DIS);
                }
            }
        }

        function touchEnd(e) {
            if (me.canDrag) {
                me.canDrag = false;

                me.autoScrollFun = function () {
                    me.scrollToLeft();
                }
                me.autoScrollTimer = setInterval(me.autoScrollFun, 5000);

                var tt = e.changedTouches[0];
                var offX = tt.pageX - me.startX;
                if (Math.abs(offX) < me.MIN_X_DIS) {
                    imageItemClicked(e.target.dataset.index);
                    return;
                }

                me.isBusy = true;
                if (Math.abs(offX) > me.w / 5) {
                    // 如果需要移动则当前元素变化，可见元素为之前的当前元素；
                    me.visibleIndex = me.currentIndex;
                    if (offX > 0) {
                        // swipe right
                        if (me.currentIndex > 0) {
                            me.currentIndex -= 1;
                        } else {
                            me.currentIndex = me.total - 1;
                        }
                    } else {
                        // siwpe left
                        if (me.currentIndex < me.total - 1) {
                            me.currentIndex += 1;
                        } else {
                            me.currentIndex = 0;
                        }
                    }
                } else {
                    // 如果不移动，则当前元素不变，可见元素是移动方向而定，为拖出来的元素
                    if (offX > 0) {
                        // swipe right
                        if (me.currentIndex == 0) {
                            me.visibleIndex = me.total - 1;
                        } else {
                            me.visibleIndex = me.currentIndex - 1;
                        }
                    } else {
                        // siwpe left
                        if (me.currentIndex == me.total - 1) {
                            me.visibleIndex = 0;
                        } else {
                            me.visibleIndex = me.currentIndex + 1;
                        }
                    }
                }
                me.render(0, true);
            }
        }
    };

    /**
     * 向左滑动一个元素，用来做自动轮播
     * @animate 是否做动画
     */
    SailfishSlider.prototype.scrollToLeft = function () {
        var me = this;
        me.visibleIndex = me.currentIndex;
        if (me.currentIndex < me.total - 1) {
            me.currentIndex += 1;
        } else {
            me.currentIndex = 0;
        }
        me.render(0, true);
    };
    /**
     * @param {number} offset 移动量
     * @param {boolean} animate 是否做动画
     */
    SailfishSlider.prototype.render = function (offset, animate) {
        var me = this;

        var items = me.dom.querySelectorAll('.slide');
        items = Array.prototype.slice.call(items);
        me.total = items.length;
        
        var timer;
        items.forEach(function (item, i) {
            var iw = me.w * (i - me.currentIndex) + offset;//所有元素排成一列
            if ((me.currentIndex == 0 && i == me.total - 1)){
                //如果当前元素为0，那么最后一个元素在左边
                iw = -me.w + offset;
            } 
            if ((me.currentIndex == me.total - 1 && i == 0)){
                //如果当前为最后一个元素，那么元素0在右边
                iw = me.w + offset;
            }

            var css = [];
            if (animate) {
                if (i == me.currentIndex || i == me.visibleIndex) {
                    //在有动画时：只有当前元素和视野内可见元素是要做动画的
                    //css.push('-webkit-transition: all 0.4s cubic-bezier(0.99, 0, 0.66, 1);');
                    css.push('-webkit-transition: all 0.3s linear;');
                    if (timer) {
                        clearTimeout(timer);
                    }
                    timer = setTimeout(function () {
                        me.isBusy = false;
                    }, 350);
                } else {
                    css.push('-webkit-transition: all 0s linear;');
                }
            } else {
                css.push('-webkit-transition: all 0s linear;');
            }
            css.push('-webkit-transform: translate3d(' + iw + 'px, 0, 0)');
            item.setAttribute('style', css.join(';'));
        });
        
        this.renderLocators();
    };

    SailfishSlider.prototype.renderLocators = function () {
        var me = this;
        if (this.liNum <= 1) {
            return;
        };
        if (!me.initLocator) {
            var locator = document.createElement('div');
            locator.className = 'locator';
            for (var i = 0; i < me.liNum; i++) {
                var span = document.createElement('span');
                span.className = 'locator-item';
                locator.appendChild(span);
            }
            me.dom.appendChild(locator);
            me.locator = locator;
            me.initLocator = true;
        }
        var locators = me.locator.querySelectorAll('.locator-item');
        locators = Array.prototype.slice.call(locators);
        if (me.liNum == 2) {
            locators.forEach(function (item, i) {
                if (i == me.currentIndex % 2) {
                    item.className = 'locator-item active';
                    BMapCom.Stat.sendOffline("poiInfoPage.bannerShow", {
                        "channel": pluginBasicData.channel,
                        "brand": pluginBasicData.brandId,
                        "c": pluginBasicData.cityId,
                        "index": me.currentIndex % 2,
                        "eventId": pluginBasicData.mbc_operation.operation_id
                    });
                } else {
                    item.className = 'locator-item';
                }
            });
        } else {
            locators.forEach(function (item, i) {
                if (i == me.currentIndex) {
                    item.className = 'locator-item active';
                    BMapCom.Stat.sendOffline("poiInfoPage.bannerShow", {
                        "channel": pluginBasicData.channel,
                        "brand": pluginBasicData.brandId,
                        "c": pluginBasicData.cityId,
                        "index": me.currentIndex,
                        "eventId": pluginBasicData.mbc_operation.operation_id
                    });
                } else {
                    item.className = 'locator-item';
                }
            });
        }
        
    };

    SailfishSlider.prototype.setSlide = function (index) {
        this.currentIndex = index;
        // 不做动画
        this.render(0);
    };

    SailfishSlider.prototype.getCurrentSlide = function () {
        return this.currentIndex;
    };

    var searchDelegator = {
        search: function (opts) {
            var self = this;

            var domain = opts.uri;
            var param = opts.operation_id + '&uid=' + pluginBasicData.uid;
            return BMapCom.Loader.jsonp(domain + param)
                .ok(function (result) {
                    if (result.data.error_msg === 'OK') {
                        self.onSourceLoadFinish(result.data.result);
                    } else {
                        BMapCom.Loader.jsonp(url)
                            .ok(function (result) {
                                if(result.data.error_msg === 'OK'){
                                    self.onSourceLoadFinish(result.data.result);
                                }
                            });
                    }
                })
                .error(function () {
                    self.onSourceLoadFailed();
                });
        }
    };
    var dataSource = new BMapCom.DataSource();
    // 绑定数据对象代理
    dataSource
        .delegate(searchDelegator)
        .delegate({
            onSourceLoadFinish: function (result) {
                listItemData = result;
                renderBannerList(listItemData);
            },
            startSourceLoad: function (param) {
                this.search(param);
            }
        });

    /**
     * 渲染banner列表,如果只有多个元素，则使用SailfishSlider类，如果只有一个则不使用
     * @param  {Arrary} result 列表元素对象数组
     */
    var renderBannerList = function (result) {
        console.log(JSON.stringify(result));
        var scrollContainer = container.querySelector('#bannerListContainer');
        var scrollScroller = container.querySelector('#bannerListScroller');
        
        var currentIndex = 0;
            liNum = result.length;

        if (liNum > 0) {
            container.style.display = 'block';
        }

        scrollScroller.innerHTML = plg.template.bannerListItem({imageData: result});
    
        // 获取滑动元素的宽度，并根据宽度设置高度(因为图片是成比例的)
        var liWidth,
            liHeight;
        liWidth = scrollContainer.clientWidth;
        liHeight = liWidth * 150 / 564;// UEmarker图中定好的图片比例

        document.querySelector('.banner-list-container').style.height = liHeight + 'px';
        var imageArr = document.querySelectorAll('.banner-list-container img')
        for (var i = 0; i < imageArr.length; i++) {
            imageArr[i].style.height = liHeight + 'px';
            imageArr[i].style.width = liWidth + 'px';
        };
        if (liNum > 1) {
            var slide = new SailfishSlider('#bannerListScroller', liWidth, liNum);            
        } else {
            scrollContainer.addEventListener('click', function () {
                imageItemClicked(0);
            });
        };
        // slide.setSlide(currentIndex);
    };

    /**
     * 滑动元素被点击是做的响应时间，与业务有关
     * @param {number} itemIndex 元素是列表中的第几个
     */
    var imageItemClicked = function (itemIndex) {
        BMapCom.Stat.sendOffline('poiInfoPage.bannerClicked', {
            "channel": pluginBasicData.channel,
            "brand": pluginBasicData.brandId,
            "c": pluginBasicData.cityId,
            "index": itemIndex,
            "eventId": pluginBasicData.mbc_operation.operation_id
        });

        if (listItemData[itemIndex].type == 1) {
            //跳转团购组件
            var requestParam = {
                "category": "groupon",
                "method": BMapCom.ComRequestMethod.DISPATCH,
                "param": {
                    "target": "target_groupon_detail",
                    "base_params": {
                        // 团单id
                        "key_detail_dealid": listItemData[itemIndex].data.nuomiid,
                        "src_channel": "poi_detail_page"
                    }
                }
            };
            BMapCom.Kernel.notify('request', requestParam);
        }
        if (listItemData[itemIndex].type == 2) {
            //跳转不需要登录的h5页面
            /*var requestParam = {
                "category": "mainmap", //基线壳
                "method": BMapCom.ComRequestMethod.DISPATCH,
                "param": {
                    "target": "web_shell_page",
                    "base_params": {
                        "webview_url":listItemData[itemIndex].data.url,
                        "webshell_is_share_show": false
                    }
                }
            };*/
            var requestParam = {
                "category": "brand",
                "method": BMapCom.ComRequestMethod.DISPATCH,
                "param": {
                    "target": "webshell_login_page",
                    "base_params": {
                        "url":listItemData[itemIndex].data.url,
                        "needLogin": 0
                    }
                }
            };
            BMapCom.Kernel.notify('request', requestParam);
        }
        if (listItemData[itemIndex].type == 3) {
            //跳转需要登录的h5页面
            var requestParam = {
                "category": "brand",
                "method": BMapCom.ComRequestMethod.DISPATCH,
                "param": {
                    "target": "webshell_login_page",
                    "base_params": {
                        "url":listItemData[itemIndex].data.url,
                        "needLogin": 1
                    }
                }
            };
            BMapCom.Kernel.notify('request', requestParam);
        }
    };

    plg.delegate({
        onInstantiate: function (data, context) {
            console.log(JSON.stringify(data));
            pluginBasicData = data;
            container = context;
            var self = this;
            container.innerHTML = self.template.bannerList();
            dataSource.update(data.mbc_operation);    
        }

    });

    return plg;
});