BMapCom.Template.create("ChildViewTpl", {
body:function ($data,$id) {
var $helpers=BMapCom.Template.helpers,$escape=$helpers.$escape,title=$data.title,i=$data.i,contents=$data.contents,width=$data.width,$out='';$out+='<div class="child-container">\n        <div class="child-title">';
$out+=$escape(title);
$out+='</div>\n        <div class="child-content">\n        ';
 for(var i = 0; i < contents.length; i++){ 
$out+='\n            <div class="child-item" style="width:';
$out+=$escape(width);
$out+='px;';
$out+=$escape((i+1)%3?'':'border-right:none');
$out+='" data-ek="childClick" data-index="';
$out+=$escape(i);
$out+='"><span style="';
$out+=$escape((i+1)%3?'':'border-right:none');
$out+='">';
$out+=$escape(contents[i].name?(contents[i].name.split('-')[1]||contents[i].name.split('-')[0]):'');
$out+='</span></div>\n            ';
 if((i+1)%3 == 0 && i < contents.length - 1){ 
$out+='\n            <div class="child-line"></div>\n            ';
 } 
$out+='\n        ';
 } 
$out+='\n        </div>\n    </div>';
return new String($out);
}});
BMapCom.Plugin.define(function(PluginBuilder) {

    var plg = PluginBuilder.create({
        hasTemplate: true,
        hasCSS: true
    });
    plg.delegate({
        onInstantiate: function(vm, context) {

            if(!vm.data || !vm.data.length) return;

            BMapCom.Stat.sendOffline('PoiDPG.RELATION.show',{
                "da_model" : "plugin_" + vm.src_name
            });

            var item = '';
            for(var i = 0; i < vm.data.length; i++){
                if (vm.data[i].detail_type == 'father_son') {
                    item = vm.data[i];
                    break;
                }
            }
            if(!item) return;

            item.width = Math.floor((context.clientWidth - 32)/3);
            item.name = vm.name;
            context.innerHTML = this.template.body(item);

            var evt = new BMapCom.EventDelegater(context);

            evt.on('childClick:tap', function(e) {

                BMapCom.Stat.sendOffline('PoiDPG.RELATION.click', {
                    da_model: 'plugin_' + vm.src_name
                });

                var index = this.getAttribute('data-index');

                if(item.contents[index].jump_type == 1){
       
                    var entranceParam = {
                        "page": "poidetailpage",
                        "pageParam": {
                            //必传参数
                           "uid": item.contents[index].son_uid || ""
                        }
                    }
                    BMapCom.Kernel.notify('changePage', entranceParam);
                }else if(item.contents[index].jump_type == 2){

                    var requestParam = {
                        "category": "mainmap",
                        "method": BMapCom.ComRequestMethod.DISPATCH,
                        "param": {
                            "target": "request_poi_detail_map_page",
                            "base_params": {
                                "uid": item.contents[index].son_uid || "",
                                "level": "18"
                            }
                        }
                    };
                    BMapCom.Kernel.notify('request', requestParam);
                }

            });

        }
    });

    return plg;
});